diff -ur ppp-2.3.11/pppd/chap.c ppp-2.3.11.mppe/pppd/chap.c
--- ppp-2.3.11/pppd/chap.c	Thu Mar 16 17:47:42 2000
+++ ppp-2.3.11.mppe/pppd/chap.c	Wed Mar 29 13:39:10 2000
@@ -69,6 +69,10 @@
     { "ms-lanman", o_bool, &ms_lanman,
       "Use LanMan passwd when using MS-CHAP", 1 },
 #endif
+#ifdef CHAPMS
+    { "chapms-strip-domain", o_bool, &chapms_strip_domain,
+      "Strip the domain prefix before the Username", 1 },
+#endif
     { NULL }
 };
 
@@ -518,6 +522,7 @@
     int secret_len, old_state;
     int code;
     char rhostname[256];
+    char tmp[256];
     MD5_CTX mdContext;
     char secret[MAXSECRETLEN];
     u_char hash[MD5_SIGNATURE_SIZE];
@@ -565,6 +570,10 @@
 	len = sizeof(rhostname) - 1;
     BCOPY(inp, rhostname, len);
     rhostname[len] = '\000';
+    if (strrchr(rhostname, '\\') && chapms_strip_domain) {
+	strcpy(tmp, strrchr(rhostname, '\\') + 1);
+	strcpy(rhostname, tmp);
+    }
 
     /*
      * Get secret for authenticating them with us,
diff -ur ppp-2.3.11/pppd/chap_ms.c ppp-2.3.11.mppe/pppd/chap_ms.c
--- ppp-2.3.11/pppd/chap_ms.c	Thu Mar 16 17:47:42 2000
+++ ppp-2.3.11.mppe/pppd/chap_ms.c	Wed Mar 29 13:44:47 2000
@@ -84,6 +84,7 @@
 bool	ms_lanman = 0;    	/* Use LanMan password instead of NT */
 			  	/* Has meaning only with MS-CHAP challenges */
 #endif
+bool	chapms_strip_domain = 0;
 
 static void
 ChallengeResponse(challenge, pwHash, response)
diff -ur ppp-2.3.11/pppd/pppd.h ppp-2.3.11.mppe/pppd/pppd.h
--- ppp-2.3.11/pppd/pppd.h	Thu Mar 16 17:47:42 2000
+++ ppp-2.3.11.mppe/pppd/pppd.h	Wed Mar 29 13:36:10 2000
@@ -226,6 +226,9 @@
 extern bool	ms_lanman;	/* Use LanMan password instead of NT */
 				/* Has meaning only with MS-CHAP challenges */
 #endif
+#ifdef CHAPMS
+extern bool	chapms_strip_domain;
+#endif
 
 extern char *current_option;	/* the name of the option being parsed */
 extern int  privileged_option;	/* set iff the current option came from root */
